/**
 Copyright (c) 2016 ETH Zurich, 2013-2016 Oliver Hilsenbeck
  
 This file is part of the linear time Maximally Stable Extremal Regions (MSER)
 implementation (based on Nistér and Stewénius, 2008) by Oliver Hilsenbeck.
  
 This implementation is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
  
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
 // Matlab
#include "mex.h"

// MSER
#include "mser.h"


/* The gateway function */
void mexFunction( int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  /* Check for proper number of arguments. */
  if(nrhs!=6) {
    mexErrMsgTxt("6 arguments required: image, delta, minSize, maxSize, maxVariation, brightOnDark");
  } else if(nlhs>1) {
    mexErrMsgTxt("Too many output arguments.");
  }
  
  /* The input image must be a noncomplex uint8.*/
  if( !mxIsClass(prhs[0], "uint8") || mxIsComplex(prhs[0]) ) {
    mexErrMsgTxt("Input image must be uint8.");
  }
  
  // Get parameters
  mwSize imageSizeY = (mwSize)mxGetM(prhs[0]);
  mwSize imageSizeX = (mwSize)mxGetN(prhs[0]);
  mwSize dimensions = mxGetNumberOfDimensions(prhs[0]);
  const unsigned char* imageData = (unsigned char*)mxGetData(prhs[0]);
  double* delta = mxGetPr(prhs[1]);
  double* minSize = mxGetPr(prhs[2]);
  double* maxSize = mxGetPr(prhs[3]);
  double* maxVariation = mxGetPr(prhs[4]);
  bool* darkOnBright = mxGetLogicals(prhs[5]);

  // Check dimensions
  if(dimensions != 2) 
      mexErrMsgTxt("Image must have 2 dimensions.");

  //if(*darkOnBright)
  //    mexWarnMsgTxt("DOB on");
  //else
  //    mexWarnMsgTxt("DOB off");
  
  try {
    // Create detector
    mser::MSERDetector* d = new mser::MSERDetector(imageSizeX, imageSizeY);
    if(!d)
        mexErrMsgTxt("Allocation failed."); 
    d->setParameters((unsigned int)*delta, (unsigned int)*minSize, (unsigned int)*maxSize, (float)*maxVariation);
    
    // Copy image data from per column to per row
    unsigned char* imageDataTmp = new unsigned char[imageSizeX * imageSizeY];
    if(!imageDataTmp) {
        delete d;
        mexErrMsgTxt("Allocation failed.");
    }
    
    for(int y = 0; y < imageSizeY; ++y) {
        for(int x = 0; x < imageSizeX; ++x) {
            imageDataTmp[y*imageSizeX + x] = imageData[x*imageSizeY + y];
        }
    }

    // Process image
    d->processImage(imageDataTmp, imageSizeX, imageSizeY, *darkOnBright);

    // Get seeds
    mser::seeds_t seeds;
    d->getMserSeeds(seeds);
    
    // Alloc return memory
    //const mwSize dimsCellArray[] = {seeds.size(), 1};
    mwSize dimsCellArray = (mwSize)seeds.size();
    plhs[0] = mxCreateCellArray(1, &dimsCellArray);
    
    // Get pixels for each MSER
    mwIndex currentCell = 0;
    for(mser::seeds_t::iterator it = seeds.begin(); it != seeds.end(); ++it) {
        unsigned int currentSeed = *it;

        // Get pixels by providing the current seed, a list to store results and the information that the seed was generated by a dark on bright search
        mser::pixels_t pixels;
        d->fillRegion(currentSeed, pixels, *darkOnBright);
        
        // Alloc return memory
        const mwSize dimsNumericArray = (mwSize)pixels.size();
        mxArray *pm = mxCreateNumericArray(1, &dimsNumericArray, mxUINT32_CLASS, mxREAL);
        
        // List pixels
        unsigned int* dest = (unsigned int*)mxGetData(pm);
        for(mser::pixels_t::iterator it2 = pixels.begin(); it2 != pixels.end(); ++it2) {
            unsigned int x = *it2 % imageSizeX;
			unsigned int y = *it2 / imageSizeX;
            
            // Add 1 beacause matlab indices start with 1
            *dest = x * imageSizeY + y + 1;
            
            /*
            if(++fo < 10) {
                char tmp[20];
                itoa(*dest, tmp, 10);
                mexWarnMsgTxt(tmp);
            }
            */
            
            ++dest;     
        }
        
        // Add pixels to cell array
        mxSetCell(plhs[0], currentCell, pm);
        ++currentCell;
    }
    
    // // Alloc return memory
    // const mwSize dims[] = {seeds.size(), 1};
    // plhs[0] = mxCreateNumericArray(2, dims, mxUINT32_CLASS, mxREAL);
    
    // // Copy seeds
    // unsigned int* dest = (unsigned int*)mxGetData(plhs[0]);
    // for(mser::seeds_t::const_iterator it = seeds.cbegin(); it != seeds.cend(); ++it) {
    //     *dest = *it;
    //     ++dest;
    // }
    
    // Cleanup
    delete d;
    delete imageDataTmp;
  }
  catch(const mser::MSERException& _e) {
      int type = _e.getType();
      
      switch(type) {
          case mser::MSERException::INVALID_PARAMETERS:
            mexErrMsgTxt("Exception during execution: Invalid parameters.");
          case mser::MSERException::ALLOC_FAILED:
            mexErrMsgTxt("Exception during execution: Allocation failed (out of memory?).");  
          default:
            mexErrMsgTxt("Exception during execution: Internal error.");  
      }
  }
}